import 'package:graphql_flutter/graphql_flutter.dart';
import 'dart:async';

/// A GraphQLClient abstraction to allow timeouts

class AdeptGraphQLClient extends GraphQLClient {
  Duration? timeout;
  AdeptGraphQLClient(
      {required super.link,
      required super.cache,
      super.defaultPolicies,
      super.alwaysRebroadcast,
      this.timeout});

  @override
  Future<QueryResult<TParsed>> query<TParsed>(QueryOptions<TParsed> options) {
    var response = super.query(options);
    return timeout != null ? response.timeout(timeout!) : response;
  }

  @override
  Future<QueryResult<TParsed>> mutate<TParsed>(
      MutationOptions<TParsed> options) {
    var response = super.mutate(options);
    return timeout != null ? response.timeout(timeout!) : response;
  }

  // @override
  // Stream<FetchResult> subscribe(Operation operation) {
  //   var response = super.subscribe(operation);
  //   return timeout != null ? response.timeout(timeout) : response;
  // }
}
